from locals import *
from scrollable_sprite import ScrollableSprite
from game import g

class Background(ScrollableSprite):
    SUPERSCROLL_SPEED = -2500

    def __init__(self):
        ScrollableSprite.__init__(self)

        self.image, self.single_size, self.superscrolling = g.assets["background"] # This is a doubled image
        self.abs_rect = self.image.get_rect()

        self.t = pygame.time.get_ticks()

    @property
    def rect(self):
        if self.superscrolling:
            t = pygame.time.get_ticks() - self.t
            super_offset = int(self.SUPERSCROLL_SPEED * (t / 1000.))

        # Get the correct rect from the "doubled" image to allow the background to repeat forever
        if self.horizontal:
            # horizontal
            if self.superscrolling:
                r = self.abs_rect.move(super_offset, 0)
            else:
                r = self.abs_rect.move(self.scroll_offset, 0)

            while r.left > 0:
                r.left -= self.single_size

            while r.right < SCREEN_WIDTH:
                r.right += self.single_size
        else:
            # vertical
            if self.superscrolling:
                r = self.abs_rect.move(0, super_offset)
            else:
                r = self.abs_rect.move(0, self.scroll_offset)

            while r.top > 0:
                r.top -= self.single_size

            while r.bottom < SCREEN_HEIGHT:
                r.bottom += self.single_size

        return r