from locals import *
from game import g

class Melee(object):
    WEAPON_SOUNDS = []
    def __init__(self, dir_facing):
        self.animation = g.assets[self.ANIMATION[dir_facing]]
        self.animation.restart_anim(lambda : g.level.player.resume_after_melee_or_shoot())

class Punch(Melee):
    ANIMATION = { DIR_LEFT : "dgp-punch-left", DIR_RIGHT : "dgp-punch-right" }
    ATTACK_TYPE = ATTACK_PUNCH
    WEAPON_SOUNDS = [ "punch1", "punch2", "punch3" ]

class Kick(Melee):
    ANIMATION = { DIR_LEFT : "dgp-kick-left", DIR_RIGHT : "dgp-kick-right" }
    ATTACK_TYPE = ATTACK_KICK
    WEAPON_SOUNDS = [ "kick1", "kick2", "kick3" ]

class Belt(Melee):
    ICON = "icon-belt"
    ANIMATION = { DIR_LEFT : "dgp-belt-left", DIR_RIGHT : "dgp-belt-right" }
    ATTACK_TYPE = ATTACK_BELT
    WEAPON_SOUNDS = [ "whip1", "whip2", "whip3", "whip5" ]

class Club(Melee):
    ICON = "icon-club"
    ANIMATION = { DIR_LEFT : "dgp-club-left", DIR_RIGHT : "dgp-club-right" }
    ATTACK_TYPE = ATTACK_CLUB
    WEAPON_SOUNDS = [ "club1", "club2", "club3" ]

class Flamethrower(Melee):
    ICON = "icon-flame"
    ANIMATION = { DIR_LEFT : "dgp-flamethrower-left", DIR_RIGHT : "dgp-flamethrower-right" }
    ATTACK_TYPE = ATTACK_FLAMETHROWER
    WEAPON_SOUNDS = [ "flamethrower1", "flamethrower2", "flamethrower3" ]

class Lasers(Melee):
    ICON = "icon-glasses"
    ANIMATION = { DIR_LEFT : "dgp-laser-left", DIR_RIGHT : "dgp-laser-right" }
    ATTACK_TYPE = ATTACK_LASER
    WEAPON_SOUNDS = [ "laser1", "laser2", "laser3", "laser4" ]
