from melee import Belt, Club, Flamethrower, Lasers
from bullet import Pistol, Bazooka, Mustache
from locals import *
from game import g
from game_object import GameObject

##### BASE ##########################################################################################

class PowerUp(GameObject):
    def take(self):
        self.kill()

class ExtraLife(PowerUp):
    ASSET_NAME = "life-powerup"

    def take(self):
        PowerUp.take(self)
        g.score.lives += 1

class MedKit(PowerUp):
    ASSET_NAME = "health-powerup"

    def take(self):
        PowerUp.take(self)
        g.score.health = min (g.score.health + 1, MAX_HEALTH)

##### WEAPONS ##########################################################################################

class WeaponPowerUp(PowerUp):
    def take(self):
        PowerUp.take(self)
        g.score.pickup_weapon(self.WEAPON)

class BeltPickup(WeaponPowerUp):
    ASSET_NAME = "icon-belt"
    WEAPON = Belt

class ClubPickup(WeaponPowerUp):
    ASSET_NAME = "icon-club"
    WEAPON = Club

class PistolPickup(WeaponPowerUp):
    ASSET_NAME = "icon-pistol"
    WEAPON = Pistol

class FlamethrowerPickup(WeaponPowerUp):
    ASSET_NAME = "icon-flame"
    WEAPON = Flamethrower

class BazookaPickup(WeaponPowerUp):
    ASSET_NAME = "icon-bazooka"
    WEAPON = Bazooka

class LasersPickup(WeaponPowerUp):
    ASSET_NAME = "icon-glasses"
    WEAPON = Lasers

class MustachePickup(WeaponPowerUp):
    ASSET_NAME = "icon-mustache"
    WEAPON = Mustache
