from consts import *

class Score(object):
    def __init__(self):
        self.lives = 5
        self.weapons = []
        self.attack_stats = {}

    def restart_level(self, level_weapon):
        self.health = MAX_HEALTH
        if level_weapon in self.weapons:
            self.weapons.remove(level_weapon)
        self.weapon_idx = len(self.weapons) - 1

    @property
    def weapon(self):
        if self.weapons:
            return self.weapons[self.weapon_idx]
        else:
            return None

    def next_weapon(self):
        if self.weapons:
            self.weapon_idx = (self.weapon_idx + 1) % len(self.weapons)

    def prev_weapon(self):
        if self.weapons:
            self.weapon_idx = (self.weapon_idx - 1) % len(self.weapons)

    def pickup_weapon(self, weapon):
        if weapon in self.weapons:
            self.weapon_idx = self.weapons.index(weapon)
        else:
            self.weapon_idx += 1
            self.weapons.insert(self.weapon_idx, weapon)

    def register_attack(self, enemy, attack):
        self.attack_stats.setdefault(enemy.__class__, {})
        self.attack_stats[enemy.__class__].setdefault(attack, 0)
        self.attack_stats[enemy.__class__][attack] += 1

    def get_possible_immunities_sorted(self, enemy):
        imm = self.attack_stats.get(enemy.__class__, {})
        return sorted([k for k, v in imm.items() if v >= 2], key = lambda k : imm[k], reverse = True)

    def all_weapons_cheat(self):
        from bullet import Pistol, Bazooka, Mustache
        from melee import Belt, Club, Flamethrower, Lasers

        self.weapons = [Belt, Club, Pistol, Flamethrower, Bazooka, Lasers, Mustache]
        self.weapon_idx = 0
